//+------------------------------------------------------------------+
//|                                                       S-RoC2.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+


#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 Yellow
//---- input parameters
extern int MA_Period=40;
extern int ROC_Period=40;
extern string Symbols="EURUSD"; 
//---- buffers
double b[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,b);
   IndicatorShortName("S-RoC("+MA_Period+", "+ROC_Period+")");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
    int i=Bars-(ROC_Period+MA_Period)-1;
   double t,curr,prev;
   while(i>=0)
   {
     curr=iMA(Symbols,0,MA_Period,0,MODE_EMA,PRICE_CLOSE,iBarShift(Symbols,0,Time[i],FALSE));
   prev=iMA(Symbols,0,MA_Period,0,MODE_EMA,PRICE_CLOSE,iBarShift(Symbols,0,Time[i+ROC_Period],FALSE ));
      if(prev!=0)
      {
         t=(curr-prev)/prev;
      }
      b[i]=t;
      i--;
      
   }
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+